(* EPITA SPE 2012/2013       *)
(* Partiel 1 - Decembre 2012 *)
(* question05                *)

let partition tab left right pivotIdx =
  let pivot = tab.(pivotIdx) in
  let storeIdx = ref left in
  begin
    tab.(pivotIdx) <- tab.(right);
    tab.(right) <- pivot;
    for i=left to right - 1 do
      if tab.(i) < pivot then
        begin
          let tmp = tab.(i) in
          tab.(i) <- tab.(!storeIdx);
          tab.(!storeIdx) <- tmp;
          incr storeIdx;
        end
    done;
    tab.(right) <- tab.(!storeIdx);
    tab.(!storeIdx) <- pivot;
    !storeIdx
  end

let rec quicksort tab left right =
  if left < right then
    begin
      let pivotNewIdx = partition tab left right (left + (right - left)/2) in
      quicksort tab left (pivotNewIdx - 1);
      quicksort tab (pivotNewIdx + 1) right;
    end
