(* EPITA SPE 2012/2013       *)
(* Partiel 1 - Decembre 2012 *)
(* question10                *)

type bw_img =
  | White
  | Black
  | Composed of bw_img * bw_img * bw_img * bw_img

let rec simplify = function
  | (White | Black) as i -> i
  | Composed (i0,i1,i2,i3)
    ->
    begin
      match (simplify i0, simplify i1, simplify i2, simplify i3) with
        | (White,White,White,White) -> White
        | (Black,Black,Black,Black) -> Black
        | (i0,i1,i2,i3)
          -> Composed (i0,i1,i2,i3)
    end
