(* EPITA SPE 2012/2013       *)
(* Partiel 1 - Decembre 2012 *)
(* question02                *)

module Q = Question02

let b2s = function
  | true -> "true"
  | _ -> "false"

let proofby9 a b c =
  b2s (Q.reduction (Q.reduction a * Q.reduction b) = Q.reduction c)

let test q =
  begin
    let (a,b) = (q#getN, q#getN) in
    Format.printf "@,@[<b>proofby9@;%d@;%d@;%d@;=@;%s (should be true)@]"
      a b (a*b) (proofby9 a b (a*b));
    Format.printf "@,@[<b>proofby9@;%d@;%d@;%d@;=@;%s (should be false)@]@,"
      a b (1 + a*b) (proofby9 a b (1 + a*b));
  end

let main () =
  begin
    let q = new Test_frame.qSeedSizeInt 2 8192 in
    q#beginParse;
    q#init;
    Format.printf
      ("@[<b 2>let proofby9 a b c =@;@[<b 2>reduction@;"
       ^^"@[<b 2>(reduction a@;*@;reduction b)@]@;=@;reduction c@]@]@,");
    Format.printf "@[<v>";
    for i=1 to q#getSize do
      test q;
    done;
    Format.printf "@]@.";
    exit 0;
  end

let _ = main ()
