(* EPITA SPE 2012/2013       *)
(* Partiel 1 - Decembre 2012 *)
(* question06                *)

module Q = Question06

let print_found = function
  | None -> Format.printf "@.@,@[<h>key not found@]@."
  | Some v -> Format.printf "@.@,@[<h>found: %03d@]@." v

let main () =
  begin
    let q = new Test_frame.qSeedSizeAsk 6 100 in
      q#beginParse;
      q#init;
      let t =
        Some (Node.factory 1 (1 lsl (8+q#getSize)) q#getSize)
      in
        (match t with Some t -> t#print | _ -> ());
        print_found (Q.find q#getKey t);
        Format.printf "@[<h>key access: %d@]@." (Node.get_count ());
	exit 0;
  end

let _ = main ()
