(* EPITA SPE 2012/2013       *)
(* Partiel 1 - Decembre 2012 *)
(* question12                *)

module Q = Question12

let basic_test () =
  let s = "A Simple Test ..." in
  begin
    Format.printf "@[<v 2>Basic test:@,";
    Format.printf "@[<h>s = %S@]@," s;
    Format.printf "@[<h>rot47 s@]@,";
    Q.rot47 s;
    Format.printf "@[<h>s = %S@]@," s;
    Format.printf "@[<h>rot47 s@]@,";
    Q.rot47 s;
    Format.printf "@[<h>s = %S@]@," s;
    Format.printf "@]@.";
  end

let random_test q =
  let s = q#make_string in
  begin
    Format.printf "@[<v 2>Random test:@,";
    Format.printf "@[<h>s = %S@]@," s;
    Format.printf "@[<h>rot47 s@]@,";
    Q.rot47 s;
    Format.printf "@[<h>s = %S@]@," s;
    Format.printf "@[<h>rot47 s@]@,";
    Q.rot47 s;
    Format.printf "@[<h>s = %S@]@," s;
    Format.printf "@]@.";
  end

let mayan q =
  let teststr = q#make_string in
  let orig = String.copy teststr in
    begin
      Q.rot47 teststr;
      if String.compare teststr orig <> 0 then
        begin
          Q.rot47 teststr;
          if String.compare teststr orig = 0 then
            begin
              Format.printf "@[<v>OK, you broke mayan code, let's try formula !@]@.";
              let (formula:string) = input_value (open_in "alumrof") in
                Q.rot47 formula;
                Format.printf "@[<h>%s@]@." formula;
            end
        end
    end

let main () =
  begin
    let q = new Test_frame.qSizeBoundedString 12 in
      q#beginParse;
      q#init;
      basic_test ();
      random_test q;
      mayan q;
      exit 0;
  end

let _ = main ()
