(* EPITA SPE 2012/2013       *)
(* Partiel 1 - Decembre 2012 *)
(* question07                *)

type peano = Zero | Succ of peano | Pred of peano

let rec add a b =
  match (a,b) with
    | (Zero, x)
    | (x, Zero)
      -> x
    | (Succ a, Pred b)
    | (Pred a, Succ b)
      -> add a b
    | (_, Succ b)
      -> add (Succ a) b
    | (_, Pred b)
      -> add (Pred a) b
