(* EPITA SPE 2012/2013       *)
(* Partiel 1 - Decembre 2012 *)
(* question05                *)

module Q = Question05

let build_array q = Array.init q#getSize (fun _ -> q#getN)

let print_array tab =
  begin
    Format.printf "@[<v>@[<h>-";
    for i = 1 to Array.length tab do
      Format.printf "------";
    done;
    Format.printf "@]@,@[<h>|";
    Array.iter (fun x -> Format.printf " %03d |" x) tab;
    Format.printf "@]@,@[<h>-";
    for i = 1 to Array.length tab do
      Format.printf "------";
    done;
    Format.printf "@]@,@]";
  end

let main () =
  begin
    let q = new Test_frame.qSeedSizeInt 5 1000 in
    q#beginParse;
    q#init;
    let tab = build_array q in
    Format.printf "Before sort:@,";
    print_array tab;
    Q.quicksort tab 0 (q#getSize - 1);
    Format.printf "After sort:@,";
    print_array tab;
    exit 0;
  end

let _ = main ()
