(* EPITA SPE 2012/2013       *)
(* Partiel 1 - Decembre 2012 *)
(* question09                *)

module Q = Question09

module RoundFloat =
struct
  type t = float

  let compare f1 f2 =
    let diff = f1 -. f2 in
    let sqdiff = (fun x -> x*.x) diff in
      if sqdiff < 1. then 0
      else if diff < 0. then -1 else 1

end

module FloatBox = Q.MaxBox (RoundFloat)

let max_list = function
  | [] -> assert false
  | h::t ->
    let box = FloatBox.create h in
      List.iter (FloatBox.update box) t;
      FloatBox.get box

let main () =
  begin
    let q = new Test_frame.qFloatList 9 15. in
      q#beginParse;
      q#init;
      let l = q#makeList in
        Test_frame.print_list_pref (Printf.sprintf "%g") l;
        Format.printf "@[<h>max l = %g@]@." (max_list l);
        exit 0
  end

let _ = main ()
